function ListViewModel( x ) {
    
	var self = this;
	
	self.fisiere 	= ko.observableArray([]);
		 
	for (var j = 0; j < x.Folders.length; j++) { 
		var folder = x.Folders[j]; 
		var folderi = new Item( true, folder.Id, folder.Title, 'directory', folder.ordering, true ); 
		self.fisiere.push(folderi);
	}

	for (var j = 0; j < x.Files.length; j++) { 
		var folder = x.Files[j]; 
		var folderi = new Item( false, folder.Id, folder.Title, folder.f_type, folder.ordering, true ); 
		self.fisiere.push(folderi);
	}

	// method to refresh the item list after an ajax call
	self.change = function ( x ) {
		self.fisiere.removeAll();

		if (typeof(x) !== 'undefined' && x !== null) {

			for (var j = 0; j < x.Folders.length; j++) { 
				var folder = x.Folders[j]; 
				var folderi = new Item( true, folder.Id, folder.Title, 'directory', folder.ordering, true ); 
				self.fisiere.push(folderi);
			}

			for (var j = 0; j < x.Files.length; j++) { 
				var folder = x.Files[j]; 
				var folderi = new Item( false, folder.Id, folder.Title, folder.f_type, folder.ordering, true ); 
				self.fisiere.push(folderi);
			}
		}

		self.fisiere.sort( function(x,y) { return self.sorting(x,y) } );
	}
	
	// method to remove an item
	self.removeFisier = function(fisier) { 
		if ( fisier.type() != 'directory' ) {
			 if (confirm(x.Lang[0])) {
				if ( self.removeFile( fisier.id() ) ) {
					self.fisiere.remove(fisier) 
				}
			}
		} else {
			 if (confirm(x.Lang[0])) {
				if ( self.removeFolder( fisier.id() ) ) {
					self.fisiere.remove(fisier) 
				}
			}
		}
	}
	
	// method to remove a folder
	self.removeFolder = function( fd_id ) {
		jQuery.ajax({
			type: "POST",
			url: "index.php?option=com_jextranet&task=folders.deleteAjax&" + x.Token + "=1",
			data: { id: fd_id },
		}).done(function( msg ) {
			var x = jQuery.parseJSON(msg);
		});
		
		return x.error ? false : true;
	}
	
	// remove a file
	self.removeFile = function( f_id ) {
		jQuery.ajax({
			type: "POST",
			url: "index.php?option=com_jextranet&task=files.deleteAjax&" + x.Token + "=1",
			data: { id: f_id },
		}).done(function( msg ) {
			var x = jQuery.parseJSON(msg);
		});
		
		return x.error ? false : true;
	}
	
	
	self.moveDown = function( fisier ) {
		
		var max	= self.fisiere().length;
		if ( max == 1 ) {
			return false;
		}

		var firstF 		= 0;
		var nextF		= 0;	
		var first 		= 0;
		var next		= 0;	
		var gasitF		= false;
		var terminateF 	= false;
		var gasit		= false;
		var terminate 	= false;
		
		for (var j = 0; j < max; j++) {
			if ( self.fisiere()[j].type() == 'directory' && fisier.type() =='directory' ) {
				if ( self.fisiere()[j].id() == fisier.id() ) {
					firstF = j;
					gasitF = true;
				} else {
					if ( !gasitF && !terminateF ) { 
						nextF = j;
					} 
					if ( gasitF && !terminateF ) {
						nextF = j;
						terminateF = true;
					}
				}
			}
			
			if ( self.fisiere()[j].type() != 'directory' && fisier.type() !='directory' ) {
				if ( self.fisiere()[j].id() == fisier.id() ) {
					first = j;
					gasit = true;
				} else {
					if ( !gasit && !terminate ) { 
						next = j;
					} 
					if ( gasit && !terminate ) {
						next = j;
						terminate = true;
					}
				}
			}
		} 
		
		// if we handle with a folder
		if ( fisier.type() == 'directory' ) {
			if ( firstF < nextF ) {
				var firstOrder 	= parseInt(fisier.order());
				var nextOrder	= parseInt(self.fisiere()[nextF].order());
				var newfile 	= new Item( true, self.fisiere()[nextF].id(), self.fisiere()[nextF].title(), self.fisiere()[nextF].type() , firstOrder, true ); 
				var newfile2	= new Item( true, fisier.id(), fisier.title(), fisier.type() , nextOrder, true ); 
				
				self.fisiere.push( newfile );
				self.fisiere.push( newfile2 ); 
				self.updateFolderOrder( self.fisiere()[nextF].id(), fisier.id(), firstOrder, nextOrder );
				self.fisiere.remove( self.fisiere()[nextF] );
				self.fisiere.remove( fisier );
			}
		} else {
			if ( first < next ) {
				var firstOrder 	= parseInt(fisier.order());
				var nextOrder	= parseInt(self.fisiere()[next].order());
				var newfile 	= new Item( false, self.fisiere()[next].id(), self.fisiere()[next].title(), self.fisiere()[next].type() , firstOrder, true ); 
				var newfile2	= new Item( false, fisier.id(), fisier.title(), fisier.type() , nextOrder, true ); 
				
				self.fisiere.push( newfile );
				self.fisiere.push( newfile2 ); 
				self.updateOrder( fisier.id(), 'down' );
				self.fisiere.remove( self.fisiere()[next] );
				self.fisiere.remove( fisier );
			}
		}
		
		self.fisiere.sort( function(x,y) { return self.sorting(x,y) } );
	}
	
	
	
	self.moveUp = function( fisier ) {
		
		var max	= self.fisiere().length;
		if ( max == 1 ) {
			return false;
		}

		var firstF 		= '';
		var nextF		= '';	
		var first 		= '';
		var next		= '';	
		var gasitF		= false;
		var gasit		= false;
		
		for (var j = 0; j < max; j++) {
			if ( self.fisiere()[j].type() == 'directory' && fisier.type() =='directory' ) {
				if ( self.fisiere()[j].id() == fisier.id() ) {
					nextF = j;
					gasitF = true;
				} else {
					if ( !gasitF ) { 
						firstF = j;
					} 
				}
			}
			
			if ( self.fisiere()[j].type() != 'directory' && fisier.type() !='directory' ) {
				if ( self.fisiere()[j].id() == fisier.id() ) {
					next = j;
					gasit = true;
				} else {
					if ( !gasit ) { 
						first = j;
					} 
				}
			}
		} 
	
		// if we handle with a folder
		if ( fisier.type() == 'directory' ) {
			if ( firstF !== 'directory' && nextF !== 'directory' && (firstF < nextF) )  { 	
				var firstOrder	= parseInt(self.fisiere()[firstF].order());
				var nextOrder 	= parseInt(fisier.order());
				var newfile 	= new Item( true, self.fisiere()[firstF].id(), self.fisiere()[firstF].title(), self.fisiere()[firstF].type() , nextOrder, true ); 
				var newfile2	= new Item( true, fisier.id(), fisier.title(), fisier.type() , firstOrder, true ); 
				
				self.fisiere.push( newfile );
				self.fisiere.push( newfile2 ); 
				self.updateFolderOrder( self.fisiere()[firstF].id(), fisier.id(), nextOrder, firstOrder );
				self.fisiere.remove( self.fisiere()[firstF] );
				self.fisiere.remove( fisier );
			}
		} else {
			if ( first !== 'directory' && next !== 'directory' && (first < next) )  {
				var firstOrder	= parseInt(self.fisiere()[first].order());
				var nextOrder 	= parseInt(fisier.order());
				var newfile 	= new Item( false, self.fisiere()[first].id(), self.fisiere()[first].title(), self.fisiere()[first].type() , nextOrder, true ); 
				var newfile2	= new Item( false, fisier.id(), fisier.title(), fisier.type() , firstOrder, true ); 
				
				self.fisiere.push( newfile );
				self.fisiere.push( newfile2 ); 
				self.updateOrder( fisier.id(), 'up' );
				self.fisiere.remove( self.fisiere()[first] );
				self.fisiere.remove( fisier );
			

			}
		}
		
		self.fisiere.sort( function(x,y) { return self.sorting(x,y) } );
	}
	
	
	
	// check if an item is a file or a folder// returns false if the item is a file, true if the item is a folder
	self.checkFolder = function ( item ) {
		return item.type() != 'directory' ? false : true;
	} 
	
	
	// get maximum order - for folders itemType = 'directory', for files itemType = type
	self.getMaxOrder = function( itemType ) {
		var max = 1;  
		ko.utils.arrayForEach( self.fisiere(), function( x ) {
			if ( itemType ) {
				if ( x.order() > max  && x.type() != 'directory' ) {
					max = x.order();
				}
			} else {
				if ( x.order() > max  && x.type() == 'directory' ) {
					max = x.order();
				}
			}
		});
		return max;
	}
	
	// method to sort the array after moving the elements
	self.sorting = function(x, y) { 
		if ( x.type() == 'directory' && y.type() != 'directory' ) {
			return -1;
		}
		
		if ( x.type() !='directory' && y.type() == 'directory' ) {
			return 1;
		}
		
		if (( x.type() == 'directory' && y.type() == 'directory' ) || ( x.type() != 'directory' && y.type() != 'directory' )) {
			 return parseInt(x.order()) == parseInt(y.order()) ? 0 : ( parseInt(x.order()) < parseInt(y.order()) ? -1 : 1 ); 
		}
	};
	
	
	// method to update file ordering
	self.updateOrder = function( f_id, ordering ) {
		jQuery.ajax({
			type: "POST",
			url: "index.php?option=com_jextranet&task=files.setFileOrderAjax&" + x.Token + "=1",
			data: { id: f_id, order: ordering },
		})
	}
	
	// method to update folder ordering
	self.updateFolderOrder = function( a, y, z, w ) {
		jQuery.ajax({
			type: "POST",
			url: "index.php?option=com_jextranet&task=folders.setOrderAjax&" + x.Token + "=1",
			data: { first: a, second: y, first_order: z, second_order: w},
		})
	}
	
	
	// method to find 
	self.search = function() {
		
		var lookfor = jQuery('#search').val();
		
		if ( lookfor ) {
			lookfor = lookfor.toLowerCase();
			var newObj = new Object;
			newObj.Files = [];
			newObj.Folders = [];
			
			for (var i = 0; i < self.fisiere().length; i++) {
				var item = self.fisiere()[i];
				var newitem = ( lookfor && item.title().toLowerCase().search(lookfor) == -1 ) ?  new Item( self.checkFolder(item), item.id(), item.title(), item.type() , item.order(), false) : new Item( self.checkFolder(item), item.id(), item.title(), item.type() , item.order(), true ); 
	
				if ( item.type() == 'directory' ) {
					newObj.Folders.push( newitem );
				} else {
					newObj.Files.push( newitem );
				}
			}
			
			self.fisiere.removeAll();
			
			for (var j = 0; j < newObj.Folders.length; j++) { 
				var folder = newObj.Folders[j]; 
				self.fisiere.push( folder );
			}
			for (var j = 0; j < newObj.Files.length; j++) { 
				var file = newObj.Files[j]; 
				self.fisiere.push( file );
			}
			self.fisiere.sort( function(x,y) { return self.sorting(x,y) } );
		}
	} 
	
	
	// method to clear filter input
	self.clear = function() {
		
		jQuery('#search').val('');
		var newObj = new Object;
		newObj.Files = [];
		newObj.Folders = [];
			
		for (var i = 0; i < self.fisiere().length; i++) {
			var item = self.fisiere()[i];
			var newitem =  new Item( self.checkFolder(item), item.id(), item.title(), item.type() , item.order(), true ); 
			
			if ( item.type() == 'directory' ) {
				newObj.Folders.push( newitem );
			} else {
				newObj.Files.push( newitem );
			}
		}
				
		self.fisiere.removeAll();
			
		for (var j = 0; j < newObj.Folders.length; j++) { 
			self.fisiere.push( newObj.Folders[j] );
		}
		for (var j = 0; j < newObj.Files.length; j++) { 
			self.fisiere.push( newObj.Files[j] );
		}
		self.fisiere.sort( function(x,y) { return self.sorting(x,y) } );
	} 
	

	self.copyfisier = function(fisier){
		jQuery.ajax({
			type: "POST",
			url: "index.php?option=com_jextranet&task=files.copyClipboard&" + x.Token + "=1",
			data: { toadd: fisier.id()},
		})
	}
	
}
