<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetControllerAlerts extends JControllerAdmin {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_ALERTS';
	

	public function getModel($name = 'Alert', $prefix = 'JExtranetModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
	
	
	// Method to delete alerts
	public function delete () {
		
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$ids = JRequest::getVar('cid', array(), '', 'array');
		$url = 'index.php?option=com_jextranet&view=alerts';
		
		if (empty($ids)) {
			
			$this->setRedirect( $url, JText::_('COM_JEXTRANET_ALERTS_ERROR_NO_ALERT_SELECTED'), 'warning' );
			
		 } else {
			
			$model = $this->getModel();
			
			if ( $model->deleteAlerts ( $ids )) {
				$this->setRedirect( $url, JText::_('COM_JEXTRANET_ALERTS_N_ITEMS_DELETED'), 'message');
			} else {
				$errors = $model->getErrors();
				$this->setRedirect( $url, implode('',$errors), 'error' );
			}
		 }
	}


}
?>
