<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetControllerFolders extends JControllerAdmin {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_FOLDERS';
	
	public function getModel($name = 'Folder', $prefix = 'JExtranetModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
	

	/**
	 * Method to delete selected folders
	 * 
	 */
	public function fdelete () {
		
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$ids 	= JRequest::getVar('cid', array(), '', 'array');
		$model 	= $this->getModel();
	
		
		if (empty($ids)) {
			$this->setRedirect( 'index.php?option=com_jextranet&view=folders', JText::_('COM_JEXTRANET_NO_SELECTED_FOLDER'), 'warning' );
			return false;
		 } 
		 
		if ( $model->deleteFolders( $ids )) {
			$this->setRedirect( 'index.php?option=com_jextranet&view=folders', JText::_('COM_JEXTRANET_FOLDERS_N_ITEMS_DELETED'), 'message' );
			return true;
		} else {
			$errors = implode( $model->getErrors() );
			$this->setMessage( $errors,'error' );
			$this->setRedirect( 'index.php?option=com_jextranet&view=folders', $errors );
			return false;
		}
	}


	public function deleteAjax () {
		
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
	
		$id 					= JRequest::getVar('id', 0, '', 'int');
		$ids					= array( $id );
		$model					= $this->getModel();
		$rezult 				= new stdclass;
		$rezult->error 			= '';
		
		if ( $model->deleteFolders( $ids ) ) {
			$rezult->error = 1;
		}
		
		flush();
		echo json_encode($rezult);
		exit();
	}
	

	public function saveOrderAjax() {

		// Get the input
		$pks = $this->input->post->get('cid', array(), 'array');
		$order = $this->input->post->get('order', array(), 'array');

		// Sanitize the input
		JArrayHelper::toInteger($pks);
		JArrayHelper::toInteger($order);

		// Get the model
		$model = $this->getModel();

		// Save the ordering
		$return = $model->saveorder($pks, $order);

		if ($return) {
			echo "1";
		}

		JFactory::getApplication()->close();
	}


	// method to set new ordering for subfolders of a folder
	// caled in the folder view
	public function setOrderAjax() {
		
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
	
		$first 	= JRequest::getVar('first', 0, '', 'int');
		$forder	= JRequest::getVar('first_order', 0, '', 'int');
		$second	=  JRequest::getVar('second', 0, '', 'int');
		$sorder	=  JRequest::getVar('second_order', 0, '', 'int');

		$pks 	= array( $first, $second );
		$order 	= array( $forder, $sorder );
		
		$this->getModel()->saveorder( $pks, $order ); 
	}
	
	
}

?>
