<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Copyright (C) 2011 Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

// Used to retrieve all notifications and receivers for a certain folder

class FolderNotifications
{
	
	public $folder;
	public $receivers 		= array();
	public $notifications 	= array();
	protected $_db;
	
	
	public function __construct( $folder ) {
		$this->_db		= JFactory::getDbo();
		$this->folder 	= $folder;
	}
	
	
	// return an array of notifications objects
	public function getNotifications() {
		
		$now	= JExtranetHelper::getSystem()->getDateToMySQL();
		$query 	= $this->_db->getQuery( true );
		$regex 	= $this->_db->quote( '"' . (int) $this->folder . '"' );
		$parents = $this->parents_search();
		
		$query->select('a.a_id AS id, a.a_description AS message, a.a_subject AS subject');
		$query->from('#__extranet_alerts AS a');
		$query->where( 'a_created <= '. $this->_db->Quote( $now ) );
		$query->where('((a.a_publish_up = "0000-00-00 00:00:00") OR (a.a_publish_up <= '. $this->_db->Quote( $now ) .'))');
		$query->where('((a.a_publish_down = "0000-00-00 00:00:00") OR (a.a_publish_down > '. $this->_db->Quote( $now ) .'))');
		
		if ($parents != '')
		{
			$query->where('(a.params REGEXP ' . $regex . ' OR a.params REGEXP ' . $parents . ')');
		}
		else 
		{
			$query->where('a.params REGEXP ' . $regex);
		}


		$this->_db->setQuery( $query );
		$notifications = $this->_db->loadObjectList();
		
		if ( $notifications ) {
			foreach ( $notifications as $notification ) {
				$this->notifications[$notification->id] = $notification;
			}
		}
	}
	
	
	// retrieve all authorized users that can receive an alert attached to a folder
	public function getAuthorizedUsers() 
	{
		$list = JExtranetHelper::getSystem()->getUsers ();
		foreach ($list as $user) 
		{
			$authLevel	= JExtranetHelper::getUser( $user->value )->getAuthorisationLevel($this->folder); 
			if ( in_array(2, $authLevel ) || in_array(3, $authLevel)) 
			{ 
				$this->receivers[] = JFactory::getUser( $user->value );
			}
		}
	}


	// parents_search :: String
	// returns an empty string if no parents or a fragment to be used in the sql query to select all recursive parent folders notifications
	protected function parents_search()
	{
		$parents = JExtranetHelper::getFolder($this->folder)->getParent(true);
		return $parents ? $this->_db->quote('("' . implode('"|"',$parents) . '").*"recursive":1.*') : '';
	}
}
