<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Copyright (C) 2011 Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetHelperAlerter
{
	protected $date;
	protected $data;
	protected $_db;


	/*
	 * @param		$data	( $data->users, $data->subject, $data->message, $data->files, $data->folder )
	 */
	public function __construct ( $data ) {

		$this->date 	= JExtranetHelper::getSystem()->getDateToMySQL();
		$this->_db		= JFactory::getDbo();
		$this->data		= $data;
	}


	public function sendEmail() {
		
		
		$from 		= JFactory::getApplication('administrator')->getCfg('mailfrom');
		$fromname	= JFactory::getApplication('administrator')->getCfg('fromname');
		$receivers 	= array();

		foreach (  $this->data->users as $key=>$receiver ) {
			if (!isset($to)) {
				$to = $receiver->email;
			} else {
				$receivers[] = $receiver->email;
			}
		}
        $method_used = JComponentHelper::getParams('com_jextranet')
                            ->get('multipleEmailsMethod', 0);
        if ($method_used == 1) {
            $cc = $receivers;
            $bcc = null;
        } else {
            $cc = null;
            $bcc = $receivers;
        }
        JFactory::getMailer()->sendMail(
            $from, $fromname, $to ,
            $this->data->subject, $this->data->message,
            $this->data->html, $cc, $bcc
        );
	}
	
	public function sendMessage() {
			
			$query 		= $this->_db->getQuery(true);
			$from 		= JFactory::getUser()->get('id');
			$receivers	= array();
			foreach (  $this->data->users as $receiver ) {
				$receivers[] = $receiver->id;
			}
			
			$columns 	= array(
								$this->_db->quoteName('m_id'),	
								$this->_db->quoteName('m_user_id_from'),
								$this->_db->quoteName('m_user_id_to'),
								$this->_db->quoteName('m_date_time'),
								$this->_db->quoteName('published'),
								$this->_db->quoteName('m_subject'),
								$this->_db->quoteName('m_message'),
								$this->_db->quoteName('checked_out')
								);
			$values = 'NULL,' . $from . ',' . $this->_db->quote(json_encode($receivers)) . ','. $this->_db->Quote( $this->date ) . ',0,' . $this->_db->Quote( $this->data->subject ) . ',' . $this->_db->Quote( $this->data->message ) . ',0';
			$query->insert('#__extranet_messages');
			$query->columns( $columns );
			$query->values( $values );
			$this->_db->setQuery($query);
			$this->_db->query();
	}

	
	public function prepare() {
		
		$website 	= JFactory::getApplication('administrator')->getCfg('sitename');
		$now		= JExtranetHelper::getSystem()->getDateToMySQL();
		
		$this->data->message = str_replace ( '__WEBSITE__', $website, $this->data->message );
		$this->data->message = str_replace ( '__FILENAME__', $this->data->files, $this->data->message );
		$this->data->message = str_replace ( '__FOLDER__', JExtranetHelper::getFolder($this->data->folder)->name, $this->data->message );
		$this->data->message = str_replace ( '__DATE__', $now, $this->data->message );
		$this->data->message = str_replace ( '__ROOT__', JExtranetHelper::getFolder(JExtranetHelper::getFolder($this->data->folder)->getMainParent())->name, $this->data->message);
		$this->data->message = str_replace ( '__ADDEDBY__', JFactory::getUser()->name, $this->data->message );
		
		$this->data->subject = str_replace ( '__WEBSITE__', $website, $this->data->subject );
		$this->data->subject = str_replace ( '__FILENAME__', $this->data->files, $this->data->subject );
		$this->data->subject = str_replace ( '__FOLDER__', JExtranetHelper::getFolder($this->data->folder)->name, $this->data->subject  );
		$this->data->subject = str_replace ( '__DATE__', $now, $this->data->subject  );
		$this->data->subject = str_replace ( '__ROOT__', JExtranetHelper::getFolder(JExtranetHelper::getFolder($this->data->folder)->getMainParent())->name, $this->data->subject);
		$this->data->subject = str_replace ( '__ADDEDBY__', JFactory::getUser()->name, $this->data->subject  );
	}

	
	
	
}
