<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyinner/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JFormHelper::loadFieldClass('list');

class JFormFieldMessageto extends JFormFieldList {

	protected $type = 'Messageto';

	public function getInput() {

		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		$filter = JFilterInput::getInstance();
		
		$query->select ('a.u_id, b.username, b.email');
		$query->from('#__extranet_users AS a');
		$query->join('inner','#__users AS b ON a.u_id = b.id');
		$query->order('a.u_id DESC');
		
		$db->setQuery( $query );
		$users = $db->loadObjectList ();

		if ( $users ) {
		
			// Initialize variables.
			$html = array();

			// Initialize some field attributes.
			$attr = $this->element['class'] ? ' class="'.(string) $this->element['class'].'"' : '';
			$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';

			$html[] = '<select id="'.$this->id.'" name="'.$this->name.'[]" '.$attr.' multiple="multiple" size="8">';
			if ( $this->value ) {
				
				// check if we have multiple destinat
				$this->value	= preg_match( '/[^0-9]/', $this->value ) ? json_decode( $this->value ) : $this->value;
				
				if ( is_array( $this->value ) ) {
					foreach ( $this->value as $dest ) {
						$html[] = '<option value="'. $dest .'"> - '. $filter->clean(JFactory::getUser( $dest )->get('name')) .' - </option>';
					}
				} elseif ( $this->value == 1 ) {
					$html[] = '<option value="'. $this->value .'"> - '. JText::_('COM_JEXTRANET_ADMIN') .' - </option>';
				} else {
					$html[] = '<option value="'. $this->value .'"> - '. JFactory::getUser($this->value)->get('name') .' - </option>';
				}
			} else {
				$html[] = '<option value="all"> - '.JText::_('COM_JEXTRANET_MESSAGE_SELECT_RECIPIENT').' - </option>';
				foreach ($users as $user) {
					$html[]='<option value="'.$user->u_id.'">'.$user->username . ' ( '. $user->email . ' )</option>';
				}
			}
			$html[] = '</select>';
			
			return implode( $html );
		}
	}
	
}
?>
