<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetModelStatistics extends JModelList
{
	protected	$option 		= 'COM_JEXTRANET_STATISTICS';
		
	public function __construct($config = array()) {
		parent::__construct($config);
	}
	
	
	
	protected function populateState( $ordering = null, $direction = null ) { 
		
		// Initialise variables.
		$app = JFactory::getApplication('administrator');
		
		// Load the parameters.
		$params = JComponentHelper::getParams('com_jextranet');
		$this->setState('params', $params);

		// List state information.
		parent::populateState();
	}
	

	
	public function getTotalPublished () {
				
		$current = JExtranetHelper::getSystem()->getDateToMySQL();
		
		$query = ' SELECT COUNT(a.f_id) AS published' .
				 ' FROM #__extranet_files AS a ' .
				 ' WHERE a.published = 1 ' .
				 ' AND ((a.f_publish_up = "0000-00-00 00:00:00") OR (a.f_publish_up <= '. $this->_db->Quote($current) .')) ' .
				 ' AND ((a.f_publish_down = "0000-00-00 00:00:00") OR (a.f_publish_down > '. $this->_db->Quote($current) .')) ';

		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	}
	
	
	public function getTotalFiles () {

		$query = ' SELECT COUNT(a.f_id)' .
				 ' FROM #__extranet_files AS a ';

		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	}
	
	
	public function getTotalUserFiles () {

		$query = ' SELECT COUNT(a.f_id)' .
				 ' FROM #__extranet_users_files AS a ';

		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	}
	
	
	public function getTotalFolders () {
		
		$query = ' SELECT COUNT(a.fd_id)' .
				 ' FROM #__extranet_folders AS a ';

		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	}
	
	public function getTotalGroups () {

		$query = ' SELECT COUNT(a.g_id)' .
				 ' FROM #__extranet_users_groups AS a ';

		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	}
	
	
	public function getTotalMessagesP () {
		
		$query = ' SELECT COUNT(a.published)' .
				 ' FROM #__extranet_messages AS a ' .
				 ' WHERE a.published = 1 ';

		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	}
	
	
	public function getTotalMessagesU () {
		
		$query = ' SELECT COUNT(a.published)' .
				 ' FROM #__extranet_messages AS a ' .
				 ' WHERE a.published = 0 ';

		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	}
	
	
	public function getFavFile () {
		
		$query = ' SELECT a.f_title FROM #__extranet_files AS a ' . 
				 ' WHERE a.f_hits = ( SELECT MAX(f_hits) FROM #__extranet_files) ';
		
		$this->_db->setQuery($query);
		$published = $this->_db->loadResult();
		
		return $published;
	
	}
	
	
	public function getFavType () {
		
		$query = ' SELECT a.f_type FROM #__extranet_files AS a ';
		$this->_db->setQuery($query);
		$res = $this->_db->loadColumn();
		$type = array();
		if (!empty($res)) {
			
			foreach ($res as $value) {
				$type[$value][] = $value;
			}
			
			$max = 0;
			foreach ($type as $k=>$v) {
				if ((count($type[$k])) > $max) {
					$maxvalue = $k;
					$max = count($type[$k]);
				}
			}
			
			return $maxvalue;
			
		} else {
			return '';
		}
		
	}
	
	
	
}
?>
