<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.keepalive');
?>
<script type="text/javascript">
	Joomla.submitbutton = function(task)
	{
		if (task == 'bulkpermissions.cancel' || document.formvalidator.isValid(document.id('user-form'))) {
			Joomla.submitform(task, document.getElementById('user-form'));
		} else {
			alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED'));?>');
		}
	}
</script>

<form action="<?php echo JRoute::_('index.php?option=com_jextranet&view=bulkpermissions'); ?>" method="post" name="adminForm" id="user-form" class="form-validate form-horizontal">

	<div class="well well-sm">
		<p><?php echo JText::_('COM_JEXTRANET_BULK_PERMISSIONS_EXPLAINED');?></p>	
		<p class="text-error"><?php echo JText::_('COM_JEXTRANET_BULK_PERMISSIONS_EXPLAINED1');?></p>	
	</div>

	<div class="span6">
		<legend><?php echo JText::_('COM_JEXTRANET_USERS', true);?></legend>
		<?php foreach ($this->users as $user) {?>
		<div class="row">
			<div class="controls">
				<label class="pull-left span1">
				<input name="users[]" value="<?php echo $user->value;?>" type="checkbox" />
				</label>
				<span class="pull-left"><?php echo $this->escape($user->text);?></span>
			</div>
		</div>
		<?php } ?>
	</div>
	
	<div class="span6">
		<legend><?php echo JText::_('COM_JEXTRANET_PERMISSIONS', true);?></legend>
			<!-- permissions tab -->
			<div class="row-fluid">
				<div class="span12">
					
					<!-- permissions accordion -->
					<div class="accordion" id="accordion2">
						<?php if ( !empty($this->folders) ) { foreach ($this->folders as $folder) { 
							if ( $this->params->get('subfolderPermission',0) == 0 && $folder->deep > 0 ) { $disabled = true; } else { $disabled = false; } 
							?>
						<div class="accordion-group">
							<div class="accordion-heading">
								<a class="accordion-toggle" data-toggle="collapse" data-parent="#accordion2" href="#collapse<?php echo $folder->id;?>">
									<?php echo str_repeat( ' - ', $folder->deep );?><i class="icon icon-folder"></i> <?php echo $this->escape($folder->name) ;?>
									<span class="pull-right"></span>
								</a>
							</div>
							<div id="collapse<?php echo $folder->id;?>" class="accordion-body collapse">
								<div class="accordion-inner">
									<?php if ( $disabled ) {?>
										<div class="alert alert-info"><p><?php echo JText::_('COM_JEXTRANET_DISABLED_MESSAGE');?></p></div>
									<?php } ?>
									<?php for ( $i = 1; $i < 7; $i++ ) { ?>
									<div class="controls">
										<label class="pull-left span1">
											<input class="permiss" name="permissions[]" type="checkbox" data-folder="<?php echo $folder->id;?>" value="<?php echo $i; ?>" <?php if( $disabled ) {?> disabled <?php } ?> />
										</label>
										<span class="pull-left">
											<?php echo JText::_('COM_JEXTRANET_USERS_FOLDER_PERMISSIONS_' . $i ) ;?>
										</span>
									</div>
									<div class="clearfix"></div>
									<?php } ?>
								</div>
							</div>
						</div>
						<?php } } ?>	
					</div>
					<!-- /permissions accordion -->
				</div>
			</div>
			<!-- /permissions tab -->
	</div>
	
	<input type='hidden' name='storage' id='storage' value='' />
	<input type="hidden" name="task" value="bulkpermissions.setValues" />
	<?php echo JHtml::_('form.token'); ?>
</form>


<script type="text/javascript">
window.addEventListener('load', function(){
	var permiss = document.querySelectorAll('.permiss');
	for (var i=0; i<permiss.length; i++){
		permiss[i].addEventListener('click',function(el){
			clicked(el.target);
		});
	}
})


// getStorage :: Void -> Obj
// return the current storage object
function getStorage() { var storage = document.getElementById('storage').value; if (storage) {return JSON.parse(storage);} else{return {};} }

// insertV :: Str -> Void
// insert a JSON encoded string into the storage
function insertV(v) {document.getElementById('storage').value = v;}


// clicked :: Elem -> Void
// modifies the storage (folder:permission) based on clicked element
function clicked(el) {
	
	if (!el){
		return;
	}
	
	var storage = getStorage();
	var el_permission = el.value;
	var el_folder = el.getAttribute('data-folder');

	if (!storage[el_folder]) {
		storage[el_folder] = [];	
	} 

	storage[el_folder] = filterValue(storage[el_folder], el_permission);
	insertV(JSON.stringify(storage));
}


// filterValue :: Array, Int ->  Array
// filter all values of original Array and return a copy with v, if v is not in original Array, or a copy without v if v is in the original Array
function filterValue(arr, v) {
	var copy = [];
	var found = false;

	arr.forEach(function(el){
		if (el == v) {
			found = true;
		} else {
			copy.push(el);
		}
	});

	if (!found) {
		copy.push(v);
	}

	return copy;
}

function bulky(){
	document.adminForm.submit();
}
</script>
