<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.formvalidation');
JHtml::_('behavior.modal', 'a.modal');

$folder = $this->item->f_id ? $this->item->f_parent : JRequest::getVar('folder','','','int');

?>
<script type="text/javascript">
	Joomla.submitbutton = function(task)
	{
		if (task == 'file.cancel' || document.formvalidator.isValid(document.id('file-form'))) {
			Joomla.submitform(task, document.getElementById('file-form'));
		} else {
			alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED'));?>');
		}
	}
</script>

<form action="<?php echo JRoute::_('index.php?option=com_jextranet&view=files&layout=edit&f_id='.(int) $this->item->f_id); ?>" method="post" name="adminForm" id="file-form" class="form-validate form-horizontal">
	
		<div class="<?php echo $this->item->f_id ? 'span4' : 'span3';?>">
			<p class="text-center size64"><i class="icon icon-file"></i></p>

			<div class="folder-label">
				<h3 class="pull-left"><?php echo $this->item->f_id ? $this->escape($this->item->f_title) : JText::_('COM_JEXTRANET_FILES_NEW'); ?></h3>
				
				<?php if ( $this->item->f_id ) { ?>
				<span class="pull-right">
					<a class="pull-left jextranet-actions" data-target="#collapseModal" data-toggle="modal"><i class="icon icon-share"></i> <span><?php echo JText::_('COM_JEXTRANET_FILES_SHARE_FILE');?></span></a>
					<a class="pull-left jextranet-actions" href="index.php?option=com_jextranet&task=folder.edit&fd_id=<?php echo $this->item->f_parent;?>"><i class="icon icon-folder"></i> <span><?php echo JText::_('COM_JEXTRANET_FILES_GO_TO_FILE_PARENT');?></span></a>
				</span>
				<?php } ?>
			</div>
			
			<?php if ( $this->item->f_id ) { ?>
			<div class="folder-details">
				
				<div class="row-fluid">
					<div class="span12">
						<div class="span5 offset1">
							<?php echo JText::_('COM_JEXTRANET_TYPE'); ?>
						</div>
						<div class="span5">
							<?php echo $this->item->f_type; ?>
						</div>
					</div>
				</div>
						
				<div class="row-fluid">
					<div class="span12">
						<div class="span5 offset1">
							<?php echo JText::_('COM_JEXTRANET_SIZE'); ?>
						</div>
						<div class="span5">
							<?php echo JExtranetHelper::getSystem()->parseSize($this->item->f_size); ?>
						</div>
					</div>
				</div>
					
				<div class="row-fluid">
					<div class="span12">
						<div class="span5 offset1">
							<?php echo JText::_('COM_JEXTRANET_CREATED'); ?>
						</div>
						<div class="span5">
							<?php echo $this->item->f_created; ?>
						</div>
					</div>
				</div>
				
				<div class="row-fluid">
					<div class="span12">
						<div class="span5 offset1">
							<?php echo JText::_('COM_JEXTRANET_FILES_AUTHOR'); ?>
						</div>
						<div class="span5">
							<?php echo JFactory::getUser($this->item->f_created_by)->get('name'); ?>
						</div>
					</div>
				</div>
				
				<div class="row-fluid">
					<div class="span12">
						<div class="span5 offset1">
							<?php echo JText::_('COM_JEXTRANET_FILES_HITS'); ?>
						</div>
						<div class="span5">
							<?php echo $this->item->f_hits; ?>
						</div>
					</div>
				</div>
									
			</div>
			<?php } ?>
		</div>
		
		<div class="span1"></div>
	
		<div class="<?php echo $this->item->f_id ? 'span6' : 'span7';?>">
			<ul class="nav nav-tabs">
				<li class="active"><a href="#general" data-toggle="tab"><?php echo JText::_('COM_JEXTRANET_DETAILS') ; ?></a></li>
				<li><a href="#metadata" data-toggle="tab"><?php echo JText::_('JGLOBAL_FIELDSET_PUBLISHING');?></a></li>
			</ul>

			<div class="tab-content">

				<div class="tab-pane active" id="general">
					<div class="row-fluid">
						<div class="span12">

							<?php $fields = array ('f_title', 'f_alias', 'f_parent', 'f_description'); ?>
							<?php foreach ( $fields as $field ) { ?>

								<?php if ( $field == 'f_type' || $field == 'f_size' ) { ?>
									<?php if ( $this->item->f_id ) { ?>
										<div class="control-group">
											<div class="control-label">
												<?php echo $this->form->getLabel($field); ?>
											</div>
											<div class="controls">
												<?php echo $this->form->getInput($field); ?>
											</div>
										</div>
									<?php } ?>
								<?php } else { ?>

							<div class="control-group">
								<div class="control-label">
									<?php echo $this->form->getLabel( $field ); ?>
								</div>
								<div class="controls">
									<?php echo $this->form->getInput( $field ); ?>
								</div>
							</div>
							<?php } } ?>

						</div>
					</div>
				</div>

				
				<div class="tab-pane" id="metadata">
					<div class="row-fluid">
						<div class="span12">
							
							<?php $fields = array ('published', 'f_publish_up', 'f_publish_down'); ?>
							<?php foreach ( $fields as $field ) { ?>

								<?php if ( $field == 'f_created' || $field == 'f_created_by' ) { ?>
									<?php if ( $this->item->f_id ) { ?>
										<div class="control-group">
											<div class="control-label">
												<?php echo $this->form->getLabel($field); ?>
											</div>
											<div class="controls">
												<?php echo $this->form->getInput($field); ?>
											</div>
										</div>
									<?php } ?>
								<?php } else { ?>

							<div class="control-group">
								<div class="control-label">
									<?php echo $this->form->getLabel( $field ); ?>
								</div>
								<div class="controls">
									<?php echo $this->form->getInput( $field ); ?>
								</div>
							</div>
							<?php } } ?>

						</div>
					</div>
				</div>

			</div>
		</div>
		
		<!-- share link -->
		<div class="modal hide fade" id="collapseModal">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal">x</button>
				<h3><?php echo JText::_('COM_JEXTRANET_FILES_SHARE_FILE');?></h3>
			</div>

			<div class="modal-body">
				<div class="control-group">
				<?php if ( $this->params->get('directDownloadLink', 0 ) ) { 
					$file = JExtranetHelper::getFile( $this->item->f_id ); ?>	
				<input type="text" onclick="this.select();" class="input-xxlarge" value="<?php echo JUri::root() . 'index.php?option=com_jextranet&task=file.download&fid=' . $this->item->f_parent . '&cid='. $this->item->f_id .'&token=' . $file->generateDownloadLink() ;?>" />
				<?php } else { ?>
					<?php echo JText::_('COM_JEXTRANET_CONFIG_ALLOW_SHARE_DISABLED');?>
				<?php } ?>
				</div>
			</div>
			
			<div class="modal-footer">
				<button class="btn" type="button" data-dismiss="modal"><?php echo JText::_('COM_JEXTRANET_CANCEL');?></button>
			</div>
		</div>
		<!-- /share link -->

	<?php echo $this->form->getInput( 'f_id' ); ?>
	<?php echo $this->form->getInput( 'f_type' ); ?>
	<?php echo $this->form->getInput( 'f_size' ); ?>
	<?php echo $this->form->getInput( 'f_created' ); ?>
	<?php echo $this->form->getInput( 'f_created_by' ); ?>
	<?php echo $this->form->getInput( 'f_hits' ); ?>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="folder" value="<?php echo $this->escape($folder); ?>" />
	<?php echo JHtml::_('form.token'); ?>
</form>
