<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JHtml::_('bootstrap.tooltip');
$listOrder	= $this->state->get('list.ordering');
$listDirn	= $this->state->get('list.direction');
$user		= JFactory::getUser();
$canChange	= $user->authorise('core.edit.state','com_jextranet');
?>

<form action="<?php echo JRoute::_('index.php?option=com_jextranet&view=messages'); ?>" method="post" name="adminForm" id="adminForm">
	
	<div id="j-sidebar-container" class="span2">
		<?php echo $this->sidebar; ?>
	</div>

	<div id="j-main-container" class="span10">

		<div id="filter-bar" class="btn-toolbar">
			<div class="filter-search btn-group pull-left">
				<input type="text" name="filter_search" id="filter_search" placeholder="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" title="" />
			</div>

			<div class="btn-group pull-left">
				<button class="btn tip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
				<button class="btn tip" type="button" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.id('filter_search').value='';this.form.submit();"><i class="icon-remove"></i></button>
			</div>
		</div>

		<div class="clr"> </div>
	
		<table class="table table-striped">
			<thead>
				<tr>
				
					<th width="1%">
						<input type="checkbox" name="toggle" value="" onclick="Joomla.checkAll(this)" />
					</th>

					<th>
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_SUBJECT', 'a.m_subject', $listDirn, $listOrder); ?>
					</th>

					<th>
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_FROM', 'a.m_user_id_from', $listDirn, $listOrder); ?>
					</th>
					
					<th>
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_TO', 'a.m_user_id_to', $listDirn, $listOrder); ?>
					</th>
					
					<th>
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_DATE', 'a.m_date_time', $listDirn, $listOrder); ?>
					</th>
					
					<th width="5%">
						<?php echo JHtml::_('grid.sort', 'COM_JEXTRANET_ID', 'a.m_id', $listDirn, $listOrder); ?>
					</th>
					
				</tr>
			</thead>

			<tbody>
			<?php foreach ($this->items as $i => $item) {
			?>
			<tr class="row<?php echo $i % 2; ?>">

				<td>
					<?php echo JHtml::_('grid.id', $i, $item->m_id); ?>
				</td>
				
				<td>
					<a href="index.php?option=com_jextranet&task=message.edit&m_id=<?php echo $item->m_id; ?>"><?php echo $this->escape($item->m_subject);?></a>
				</td>

				<td>
					<?php echo $this->escape(JFactory::getUser($item->m_user_id_from)->get('username')); ?>
				</td>
				
				<td>
					<?php if (preg_match('/[^0-9]/', $item->m_user_id_to)) { $item->m_user_id_to = json_decode( $item->m_user_id_to ); } ?>
					<?php if( is_array( $item->m_user_id_to )) { foreach ( $item->m_user_id_to as $dest ) {?>
						<?php echo $this->escape(JFactory::getUser( $dest )->get('username')) ;?>, 
					<?php } }  elseif ( $item->m_user_id_to == 1 ) { 
						echo JText::_('COM_JEXTRANET_ADMIN'); 
						} else {
							echo $this->escape(JFactory::getUser($item->m_user_id_to)->get('username'));
						} 
					?>
				</td>
				
				<td>
					<?php echo $item->m_date_time; ?>
				</td>
				
				<td>
					<?php echo $item->m_id; ?>
				</td>
				
			</tr>
			<?php } ?>
			</tbody>
					
			<tfoot>
				<tr>
					<td colspan="7">
						<?php echo $this->pagination->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
		</table>
	</div>

		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
		<?php echo JHtml::_('form.token'); ?>
</form>
