<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('behavior.keepalive');
?>
<script type="text/javascript">
	Joomla.submitbutton = function(task)
	{
		if (task == 'user.cancel' || document.formvalidator.isValid(document.id('user-form'))) {
			Joomla.submitform(task, document.getElementById('user-form'));
		} else {
			alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED'));?>');
		}
	}
	
	var folderData = {
		user: '<?php echo $this->item->u_id;?>',
		Token: '<?php echo JSession::getFormToken();?>',
		Lang: ["<?php echo JText::_('COM_JEXTRANET_FOLDERS_DELETE_CONFIRM');?>"],
		Files: <?php echo json_encode( $this->userfiles );?>,
	};
	
	function dropit( id ) {
		var identif = '#dropit'+id;
		var size = jQuery(identif).attr('size');
		jQuery('.permissions').attr('size', 1);
		size == 1 ? jQuery(identif).attr('size', 10) : jQuery(identif).attr('size', 1);
	}
</script>

<form
    action="<?php echo JRoute::_('index.php?option=com_jextranet&view=user&layout=edit&u_id='.(int) $this->item->u_id); ?>"
    method="post" name="adminForm" id="user-form"
    class="form-validate form-horizontal">

	<div class="span4">
		<p class="text-center size64"><i class="icon icon-user"></i></p>
        <?php if ($this->item->u_id){
        $user = JExtranetHelper::getUser($this->item->u_id); ?>

		<div class="folder-label">
            <h3 class="pull-left">
                <?php echo $this->escape($user->get('name')); ?></h3>
		
			<span class="pull-right">
                <a class="pull-left jextranet-actions"
                    href="#" onclick="toggleUploader();">
                    <i class="icon icon-upload"></i>
                    <span>
                    <?php echo JText::_('COM_JEXTRANET_USERS_ADD_FILE_VAULT');?>
                    </span></a>
                <a class="pull-left jextranet-actions"
                    href="index.php?option=com_users&task=user.edit&id=<?php echo $this->item->u_id;?>">
                    <i class="icon icon-user"></i>
                    <span>
                    <?php echo JText::_('COM_JEXTRANET_USERS_JOOMLA_CORRESPONDENT');?>
                    </span></a>
			</span>
		</div>

		<!-- user info -->
		<div class="folder-details">
			<div class="row-fluid">
				<div class="span12">
					<div class="span5 offset1">
						<?php echo JText::_('COM_JEXTRANET_USERS_USERNAME'); ?>
					</div>
					<div class="span5">
						<?php echo $user->get('username');?>
					</div>
				</div>
			</div>
					
			<div class="row-fluid">
				<div class="span12">
					<div class="span5 offset1">
						<?php echo JText::_('COM_JEXTRANET_EMAIL');?>
					</div>
					<div class="span5">
						<?php echo $user->get('email');?>
					</div>
				</div>
			</div>
		</div>
		<!-- /user info -->
		
		
		<!-- add multi files -->
		<div class="row-fluid" id="uploader" style="display:none;">
			<div class="span12 uploadx" style="position:relative; min-height:250px;">
                    <div id="upload" class="span5 pull-left"
                        style="border:2px dashed #ddd; height:200px;"></div>
                    <div id="uploaded" class="span6 pull-left"
                        style="border: 1px solid #ddd; height:200px; background:#ecf0f1; color:#2c3e50"></div>
			</div>
		</div>
		<!-- /add multi files -->
					
		<?php } ?>
	</div>
	
	<div class="span1"></div>
	
	<div class="span6">
        <?php echo JHtml::_('bootstrap.startTabSet', 'myTab',
                                array('active' => 'general')); ?>

            <?php echo JHtml::_('bootstrap.addTab', 'myTab', 'general',
                                    JText::_('COM_JEXTRANET_DETAILS', true));?>
			<!-- user editing details -->
			<div class="row-fluid">
				<div class="span12">
                    <?php $items = array(
                            'g_id', 'block', 'allowUserUploadOwnFolder'
                        ); 
                        foreach ( $items as $item ) { ?>
					<div class="control-group">
						<div class="control-label">
							<?php echo $this->form->getLabel( $item ); ?>
						</div>
						<div class="controls">
							<?php echo $this->form->getInput( $item ); ?>
						</div>
					</div>
					<?php } ?>
				</div>
			</div>
			<!-- /user editing details -->
			<?php echo JHtml::_('bootstrap.endTab'); ?>


            <?php echo JHtml::_('bootstrap.addTab', 'myTab', 'permissions',
                                JText::_('COM_JEXTRANET_PERMISSIONS', true));?>
            <?php echo $this->loadTemplate('permissions');?>
			<?php echo JHtml::_('bootstrap.endTab'); ?>


            <?php echo JHtml::_('bootstrap.addTab', 'myTab', 'firstpage',
                    JText::_('COM_JEXTRANET_USERS_CUSTOM_FIRST_PAGE', true));?>
			<div class="row-fluid">
				<div class="span12">
					<?php echo $this->form->getInput('firstPageContent'); ?>
				</div>
			</div>
            <?php echo JHtml::_('bootstrap.endTab'); ?>
			
            <?php echo JHtml::_('bootstrap.addTab', 'myTab', 'custom',
                        JText::_('COM_JEXTRANET_USERS_CUSTOM_PAGES', true));?>
			<?php $fieldset = $this->custom_pages->getFieldset('details');
			foreach ( $fieldset as $field ) { ?>
			<div class="row-fluid">
				<div class="span12 form-horizontal">
					<div class="form-group">
							<label class="span2">
								<?php echo $field->label; ?>
							</label>
						<div class="span10">
							<?php echo $field->input; ?>
						</div>
					</div>
                </div>
            </div>
            <?php } ?>		
            <?php echo JHtml::_('bootstrap.endTab'); ?>
			
            <?php $tab = JText::_('COM_JEXTRANET_USERS_FILE_VIEW', true) .
                        '('.JText::_('COM_JEXTRANET_YOUR_FILES', true).')'; ?>
 			<?php echo JHtml::_('bootstrap.addTab', 'myTab', 'userfiles', $tab);?>
 			<!-- vault files -->
            <?php echo $this->loadTemplate('vault');?>
			<!-- /vault files -->
			<?php echo JHtml::_('bootstrap.endTab'); ?>
			
		<?php echo JHtml::_('bootstrap.endTabSet'); ?>
	</div>
	<script type="text/javascript">
	
		function toggleUploader() {
			var uploader = document.getElementById('uploader');
			if ( uploader.style.display == 'none' ) {
				uploader.style.display = 'block'; 
			} else {
				uploader.style.display = 'none' ;
			}
		}

		jQuery().ready(function() {

			var errors="";
			
			jQuery('#upload').mfupload({
				type		: '',	//all types
				maxsize		: '500',
				post_upload	: "<?php echo JUri::root();?>administrator/index.php?option=com_jextranet&task=userfiles.uploadAjax&<?php echo JSession::getFormToken();?>=1&id=<?php echo $this->item->u_id;?>",
				id			: "<?php echo $this->item->u_id;?>",
				ini_text	: "<?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_DRAG_USERFILE');?>",
				over_text	: "<?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_DROP_HERE');?>",
				over_col	: 'white',
				over_bkcol	: '#27ae60',
				init		: function(){		
					jQuery("#uploaded").empty();
				},
				start		: function(result){		
					jQuery("#uploaded").append("<div id='FILE"+result.fileno+"' class='files'>"+result.filename+"<div id='PRO"+result.fileno+"' class='progress'></div></div>");	
				},
				loaded		: function(result){
					jQuery("#PRO"+result.fileno).remove();
					jQuery("#FILE"+result.fileno).html("<?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_UPLOADED');?>: "+result.filename+" ("+result.size+")");	
					if ( result.error ) {
						jQuery("#FILE"+result.fileno).html("<?php echo JText::_('COM_JEXTRANET_MULTI_UPLOAD_ERRORS');?>: "+result.error);	
					}		
				},
				progress	: function(result){
					jQuery("#PRO"+result.fileno).css("width", result.perc+"%");
				},
				error		: function(error){
					errors += error.filename+": "+error.err_des+"\n";
				},
				completed	: function( result ){
                    vault.uploadFinish();
				}
			});   	
		});
	</script>


	<?php echo $this->form->getInput('u_id'); ?>
	<input type="hidden" name="task" value="" />
	<?php echo JHtml::_('form.token'); ?>
</form>
