<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetViewUser extends JViewLegacy
{
	protected $item;
	protected $form;
	protected $state;
	protected $json;
	protected $userfiles;
	protected $params;
    protected $custom_pages;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->item			= $this->get('Item');
		$this->form			= $this->get('Form');
        $this->json	= $this->getModel()->permissionsJsonData(0, 0,
                                                            $this->item->u_id);
        $this->userfiles	= JExtranetHelper::getUser($this->item->u_id)
                                                            ->getVaultFiles();
		$this->params		= JComponentHelper::getParams('com_jextranet');
        $this->custom_pages = $this->get('CustomPages');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		parent::display($tpl);
	}

	protected function addToolbar() {
	
		JHTML::_('script','administrator/components/com_jextranet/assets/js/mfupload.js');
        JHtml::_('script', 'https://cdn.jsdelivr.net/npm/vue');
		JHtml::stylesheet( 'administrator/components/com_jextranet/assets/css/default.css' );
		
		$canDo		= JExtranetHelper::getSystem()->getActions();
		
		JToolBarHelper::title(JText::_('COM_JEXTRANET_EDIT'), 'user');
	

		// If not checked out, can save the item.
		if ($canDo->get('core.edit')||($canDo->get('core.create'))) {
			JToolBarHelper::apply('user.apply', 'JTOOLBAR_APPLY');
			JToolBarHelper::save('user.save', 'JTOOLBAR_SAVE');
		}

		if (empty($this->item->u_id))  {
			JToolBarHelper::cancel('user.cancel','JTOOLBAR_CANCEL');
		} else {
			JToolBarHelper::cancel('user.cancel', 'JTOOLBAR_CLOSE');
		}
	}
}
?>
