<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class JExtranetControllerFile extends JControllerLegacy {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_FILE';
	protected 	$preview = 0;
	
	public function getModel($name = 'File', $prefix = 'JExtranetModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}


	public function download () 
	{
		$token 	= JRequest::getVar('token');
		$helper	= JExtranetHelper::getSystem();
		$fid 	= JRequest::getVar('fid','0','','int');
		$id 	= JRequest::getVar('cid',0,'','int');
		
		if ($token && JComponentHelper::getParams('com_jextranet')->get('directDownloadLink')) 
		{
			if (!$helper->checkToken($token, $id)) 
			{ 
				jexit(JText::_('JINVALID_TOKEN'));
			}

			// if the token is veryfied, store the file id so we can verify to which file he has direct access
			JFactory::getApplication()->setUserState('direct.download.id', $id);
		} 
		else 
		{
			JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		}
		
		if (empty($id)) 
		{
			$this->setRedirect(JRoute::_('index.php?option=com_jextranet&view=folders&fid=' . $fid, false), JText::_('COM_JEXTRANET_FILE_NO_SELECTED'), 'warning');
		} 
		else 
		{
			$this->setRedirect(JRoute::_('index.php?option=com_jextranet&view=file&id=' . $id . '&preview=' . $this->preview, false));
		}
	}


	public function preview()
	{
		$this->preview = 1;
		$this->download();
	}
	
	
	public function bookmark () {
			
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		
		$fid 	= JRequest::getVar('fid',0,'','int');
		$id 	= JRequest::getVar('cid',0,'','int');
		$url 	= JRoute::_('index.php?option=com_jextranet&view=folders&fid=' . $fid, false);

		if (empty($id)) {
			$this->setRedirect( $url, JText::_('COM_JEXTRANET_FILE_NO_SELECTED'), 'warning' );
		} else {
			$model = $this->getModel();
			if ($model->bookmark($id)) {
				$this->setRedirect( $url, JText::_('COM_JEXTRANET_FILE_BOOKMARKED'), 'message' );
			} else {
				$this->setRedirect( $url, JText::_('COM_JEXTRANET_FILE_BOOKMARKED_NOT_ALLOWED'), 'warning' );
			}	
		}
	}


	function upload() {
		 
		// Check for request forgeries
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));

		$files = array();
		$model = $this->getModel();
		$rezult = array();
		$id = JRequest::getVar ('folder',0,'','int');

		if(!empty($_FILES['mf_file_upload']))
		{
			foreach ($_FILES['mf_file_upload'] as $key => $values)
			{
				if (is_array($values))
				{
					foreach ($values as $k => $v)
					{
						if (!isset($files[$k]))
						{
							$files[$k] = array();
						}

						$files[$k][$key] = $v;
					}
				}
				else
				{
					$files[0][$key] = $values;
				}
			}
		}

		if (!empty($files))
		{
			foreach ($files as $file)
			{
				$rezult[] = $model->upload($file,$id);
			}
		}

		flush();
		echo json_encode($rezult);
		exit();
	}

	
	public function delete() {

		$model = $this->getModel();
		$return = JRequest::getVar('return','','','base64');

		if ( !$model->fdelete() ) {
			$this->setRedirect( base64_decode($return), $model->getErrors(), 'warning');
			return;
		} 

		$this->setRedirect( base64_decode($return), JText::_('COM_JEXTRANET_FOLDERS_DELETE_FILE_SUCCESS'), 'message');
		return;
	}
	
	
	public function download_all()
	{
		// Check for request forgeries
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		
		$fid 	= JFactory::getApplication()->input->get('fid',0,'int');
		$return = JFactory::getApplication()->input->get('return','','base64');
		$zips 	= JFactory::getApplication()->input->get('zip',array(),'array');
		
		$folder = JExtranetHelper::getFolder($fid);
		$user 	= JExtranetHelperUser::getInstance();
		$system = JExtranetHelper::getSystem();
		

		if(!class_exists('ZipArchive'))
		{
			$this->setRedirect(base64_decode($return), JText::_('COM_JEXTRANET_UNABLE_TO_ZIP_MISSING'), 'warning');
			return;
		}
		
		// if he can't download files from this folder or no files selected
		if (!in_array(3, $user->getAuthorisationLevel($fid)) || empty($zips))
		{
			$this->setRedirect(base64_decode($return), JText::_('COM_JEXTRANET_UNABLE_TO_ZIP_NO_SELECTION_RIGHTS'), 'warning');
			return;
		}


		$zip = new ZipArchive();
		$temp = JPATH_CONFIGURATION . '/tmp/jextranet' . time() . '.zip';
		$res = $zip->open($temp, ZipArchive::CREATE | ZipArchive::OVERWRITE);
	
		foreach ($zips as $z)
		{
			$file = $system::getFileDetails($z);
			
			if (in_array(3, $user->getAuthorisationLevel($file->f_parent)))
			{
				$zip->addFile($folder->uploadBase . $file->f_alias, $file->f_title . '.' . $file->f_type);
			}
		}
		
		$zip->close();
		
		if (ob_get_level()) ob_end_clean();
		
		header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); 
		header("Content-Type: application/zip");
		header('Content-Disposition: attachment; filename="zip' . date('ymdhis') . '.zip";');
		header("Accept-Ranges: bytes");
		//header('Content-Length: ' . filesize($temp));

		print readfile($temp);
		
		JFile::delete($temp);
		exit;
	}
	

	function notify() {
		 
		// Check for request forgeries
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));

		$data = file_get_contents("php://input");
		$folder = JFactory::getApplication()->input->get('folder', 0, true);

		if ($data) {
			$files = json_decode($data);
			$alerter = new JExtranetHelperAlerter($folder);
			$alerter->setFiles($files);
			$alerter->notify();
		}
		exit();
	}
}
