<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetControllerUserfiles extends JControllerLegacy {
	
	protected	$option 		= 'com_jextranet';
	protected 	$text_prefix	= 'COM_JEXTRANET_USERFILES';
	
	public function getModel($name = 'Userfiles', $prefix = 'JExtranetModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}

	
	/*
	 * Method to archive selected files to download
	 * 
	 * @param
	 * @return
	 */
	public function download () {
		
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		
		$id 	= JRequest::getVar('cid',0,'','int');
		
		if ( empty( $id )) {
			$this->setRedirect( JRoute::_('index.php?option=com_jextranet&view=userfiles',false), JText::_('COM_JEXTRANET_USERFILES_NO_SELECTED'), 'warning' );
			return false;
		}
		
		$document	= JFactory::getDocument();
		$vName		= 'userfiles';
		$vFormat	= 'raw';
			
		if ($view = $this->getView($vName, $vFormat)) {
				
			$model = $this->getModel();
			$view->setModel($model, true);
			$view->assignRef('document', $document);
			$view->display();
		}
	}
	
	
	public function remove() {
	
		JRequest::checkToken('request') or jexit(JText::_('JINVALID_TOKEN'));
		
        if (JComponentHelper::getParams('com_jextranet')->get('allowUserDeleteVaultFiles',0) == 0) {
            $this->setRedirect(
                JRoute::_('index.php?option=com_jextranet&view=userfiles',false)
            );
            return;
        }

		$ids 	= JRequest::getVar('cids', array(),'','array');
		
		if (empty($ids)) {
			$this->setRedirect( JRoute::_('index.php?option=com_jextranet&view=userfiles',false), JText::_('COM_JEXTRANET_USERFILES_NO_SELECTED'), 'warning' );
			return false;
		}

		$model = $this->getModel();
		$model->remove( $ids );
		$this->setRedirect( JRoute::_('index.php?option=com_jextranet&view=userfiles',false), JText::_('COM_JEXTRANET_USERFILES_REMOVED'), 'message' );
		return true;
	}
	
	
	
}
?>
