<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Copyright (C) 2011 Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');



class JExtranetModelBookmarks extends JModelList
{
	protected 	$current;
	protected 	$params;
	
	public function __construct($config = array()) {
		
		$this->current 	= JExtranetHelper::getSystem()->getDateToMySQL();
		$this->user 	= JExtranetHelperUser::getInstance();
		$this->params	= JComponentHelper::getParams('com_jextranet');

		parent::__construct($config);
	}
	
	public function getBookmarks () {
		
		// we check if bookmarks aren't disabled from back-end Options
		$disabled = $this->params->get( 'userMenuItemsRemoved', array() );
		if ( in_array( 3, $disabled )) {
			return false;
		}
		
		$u_params = $this->user->getParams();
		if(isset($u_params->bookmarks)) {
			$query = $this->_db->getQuery(true);
			$query->select('a.f_id, a.f_title, a.f_type, a.f_size');
			$query->from('#__extranet_files AS a');
			$query->where('a.f_id IN (' . implode(',', $u_params->bookmarks ) . ')' );
			$query->where('a.published = 1');
			$query->where('(a.f_publish_up = ' . $this->_db->quote('0000-00-00 00:00:00') . ' OR a.f_publish_up < ' . $this->_db->quote($this->current) . ')' );
			$query->where('(a.f_publish_down = ' . $this->_db->quote('0000-00-00 00:00:00') . ' OR a.f_publish_down > ' . $this->_db->quote($this->current) . ')' );
		
			$this->_db->setQuery( $query );
			return $this->_db->loadObjectList();
		}

		return false;
	}
	

	
	public function remove ( ) {

		$u_params = $this->user->getParams();
		unset($u_params->bookmarks);
		$newparams = json_encode( $u_params );
		
		$query = $this->_db->getQuery ( true );	
		$query->update( '#__extranet_users' );
		$query->set( 'u_params = ' .  $this->_db->Quote($newparams) );
		$query->where( 'u_id = ' . $this->user->get('id') );
		$this->_db->setQuery ( $query );
		$this->_db->query();
	}
	
	
	
}
?>
