<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

class JExtranetModelMessages extends JModelList
{
	protected	$option 		= 'COM_JEXTRANET';
	


	public function getListQuery() {
		
		$disabled 	= JComponentHelper::getParams('com_jextranet')->get( 'userMenuItemsRemoved', array() );
		$user		= JFactory::getUser()->get('id');
		
		if ( in_array( 2, $disabled )) {
			return false;
		}

		// Create a new query object.
		$query	= $this->_db->getQuery(true);

		// Select the required fields from the table.
		$query->select(
			$this->getState(
				'list.select','a.m_id, a.m_subject, a.m_date_time, a.m_user_id_to, a.published'
			)
		);
		$query->from(' #__extranet_messages AS a');
		$query->where(' (a.m_user_id_to = ' . $user  . '  OR a.m_user_id_to REGEXP \'\"'.$user.'\"\' OR (a.m_user_id_to = 1 AND a.m_user_id_from =' . $user .'))');
		
		// Filter by search in title
		$search = $this->getState('filter.search');
		if (!empty($search)) {
			$search = $this->_db->Quote('%'.$this->_db->escape($search, true).'%');
			$query->where('( a.m_subject LIKE '.$search.' )');
		}
		
		// Add the list ordering clause.
		$orderCol = $this->getState('list.ordering', 'a.m_id');
		$query->order($this->_db->escape($orderCol) .' '. $this->_db->escape($this->getState('list.direction', 'DESC')));

		return $query;

	}
		
	
	/**
	 * Method to delete selected messages
	 * 
	 * @param		array $messages 	ID's of the messages to be deleted
	 * @return 		void
	 **/
	public function delete ($messages) 
	{
		
		if (empty($messages))
		{
			return;
		}

		$user = JFactory::getUser()->get('id');
		$query = $this->_db->getQuery(true);
		
		$query->delete('#__extranet_messages');
		$query->where( 'm_id IN (' . implode(',',$messages) . ') AND ( m_user_id_to = ' . $user . ' OR m_user_id_from = ' . $user . ' OR m_user_id_to REGEXP \'\"'.$user.'\"\' )' );
		$this->_db->setQuery( $query );
		$this->_db->query();
	}
	
}
