<?php
/*
 * @component J!Extranet
 * @website : ionutlupu.me
 * @copyright Ionut Lupu. All rights reserved.
 * @license : http://www.gnu.org/copyleft/gpl.html GNU/GPL , see license.txt
 */
 
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.client.helper');

class JExtranetModelUserfiles extends JModelList
{
	protected	$option 		= 'COM_JEXTRANET';
	protected 	$current;
	protected	$base;
	protected 	$file;

	public function __construct($config = array()) {

		$this->current 	= JExtranetHelper::getSystem()->getDateToMySQL();
		$this->base 	= JExtranetHelper::getSystem()->getUploadFolder();
		
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'a.f_id '
			);
		}
		parent::__construct($config);
	}
	

	protected function populateState( $ordering = null, $direction = null ) { 

		parent::populateState('a.f_id', 'desc');
	}

	
	protected function getStoreId($id = '') {

		return parent::getStoreId($id);
	}
	

	public function getListQuery() {
		
		
		// if userfiles is disabled from back-end Options
		$disabled = JComponentHelper::getParams('com_jextranet')->get( 'userMenuItemsRemoved', array() );
		if ( in_array( 4, $disabled )) {
			return false;
		}

		// Create a new query object.
		$query	= $this->_db->getQuery(true);

		// Select the required fields from the table.
		$query->select(
			$this->getState(
				'list.select','a.f_id, a.f_title, a.f_type, a.f_size, a.f_created, a.f_alias '
			)
		);
		$query->from(' #__extranet_users_files AS a');
		$query->where(' a.f_created_by = ' . JFactory::getUser()->get('id') );
		
		// Filter by search in title
		$search = $this->getState('filter.search');
		if (!empty($search))
		{
			if (stripos($search, 'id:') === 0) {
				$query->where('a.f_id = '.(int) substr($search, 3));
			}
			else
			{
				$search = $this->_db->Quote('%'.$this->_db->escape($search, true).'%');
				$query->where('( a.f_title LIKE '.$search.' )');
			}
		}
		
		// Add the list ordering clause.
		$orderCol = $this->getState('list.ordering', 'a.f_id');
		$query->order($this->_db->escape($orderCol).' '.$this->_db->escape($this->getState('list.direction', 'DESC')));

		return $query;

	}
	

	public function getFile() {
		
		$id 	= JRequest::getVar('cid',0,'','int');
		$user 	= JFactory::getUser()->get('id');

		$query	= $this->_db->getQuery(true);
		
		$query->select('a.f_title, a.f_alias, a.f_size');
		$query->from('#__extranet_users_files AS a');
		$query->where( 'a.f_id = ' . (int) $id );
		$query->where( 'a.f_created_by = ' . (int) $user );
		$this->_db->setQuery($query);
		$obj = $this->_db->loadObject();

		if ( $obj ) {
			
			$file = new stdclass();

			$file->content = JFile::read( $this->base .  DIRECTORY_SEPARATOR . 'extranet_ufiles' . DIRECTORY_SEPARATOR . $user . DIRECTORY_SEPARATOR . $obj->f_alias );
			$file->size = $obj->f_size;
			$file->name = $obj->f_alias;
			$file->type = 'application/octet-stream';

			return $file;
		} 
		return false;
	}

	
	public function remove($ids) 
	{
		$user 	= JFactory::getUser()->get('id');
		
		$query = $this->_db->getQuery ( true );
		$query->select('a.f_id,a.f_title, a.f_alias');
		$query->from('#__extranet_users_files AS a');
		$query->where( 'a.f_id IN ('.implode(',',$ids).')' );
		$this->_db->setQuery($query);
		$files = $this->_db->loadObjectList();
		
		if (!empty($files)) 
		{
			$d = array();

			foreach ($files as $file) 
			{
				array_push($d, $file->f_id);	
				$filepath =  $this->base . DIRECTORY_SEPARATOR . 'extranet_ufiles' . DIRECTORY_SEPARATOR . $user . DIRECTORY_SEPARATOR . $file->f_alias;
				JFile::delete($filepath);
			}

			$query->clear();
			$query->delete('#__extranet_users_files');
			$query->where('f_id IN ('.implode(',',$d).')');
			$this->_db->setQuery($query);
			$this->_db->query();
		}
	}
}
